#include <cmath>
#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXF = 100;
const int MAXS = 100;
const int MAXP = 100;

enum Tipo {urbana, extraurbana}; 

struct Coord {
  double x;
  double y;
};

struct Fermata {
  int id;
  char indirizzo[MAXS];
  Coord coord;
  Tipo tipo;
};

struct Linea {
  char nome[MAXS];
  int idferm[MAXF];
  int numIdferm; 
};

struct Piano {
  Linea lin[MAXP];
  Fermata fer[MAXF];
  int numLinee;
  int numFermate;
};


bool caricaPiano(Piano* pp, const char filefermate[], const char filelinee[]);
bool percorsoPiuLungo(const Piano* pp, char ris[]);
void perIndirizzo(const Piano* pp, const char ind[]);
int lineeInArea(const Piano* pp, const Coord as, const Coord bd);
void stampa(const Piano* pp);

void menu() {
  cout << "\n\n----------------------" << endl;
  cout << "1) carica piano" << endl;
  cout << "2) percorso piu' lungo" << endl;
  cout << "3) per indirizzo" << endl;
  cout << "4) linee in area" << endl;
  cout << "5) stampa" << endl;
  cout << "6) esci" << endl;
  cout << "? ";
}

Coord leggiCoord(){
  Coord c;
  cout << "x? ";
  cin >> c.x;
  cout << "y? ";
  cin >> c.y;
  return c;
}

int main(){
  Piano piano;
  piano.numFermate = 0;
  piano.numLinee = 0;
 
  char c;
  bool res;
  Coord c1, c2;
  int k;
  char ind[MAXS];
  char s[MAXS];

  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1': 
        res = caricaPiano(&piano, "fermate.txt", "linee.txt");  
        if(res) cout << "Caricamento ok" << endl;
        else cout << "Problema durante il caricamento" << endl; 
        break;
      case '2': 
        res = percorsoPiuLungo(&piano, s);
        cout << "La linea che esegue il percorso piu' lungo e': " << s << endl;
        break;
      case '3': 
        cout << "Inserisci l'indirizzo: " << endl;
        cin >> ind;
        perIndirizzo(&piano, ind);        
        break;
      case '4': 
        cout << "Inserisci le coordinate del punto in alto a sx" << endl;
        c1 = leggiCoord();        
        cout << "Inserisci le coordinate del punto in basso a dx" << endl;
        c2 = leggiCoord();
        k = lineeInArea(&piano, c1, c2);
        cout << "Nell'area ci sono " << k << " linee" << endl;
        break;
      case '5': 
        stampa(&piano);
        break;
      case '6': 
        return 0;
    }
  }
}
